;31 baud PSK for 56002evm.
;by G3PLX  August 1996
;if you have modification suggestions for this program,
;please pass them back to the author FIRST.
;peter.martinez@btinternet.com
;Peter Martinez
;High Blakebank Farm
;Underbarrow
;Kendal
;Cumbria LA8 8BN
;United Kingdom

        include 'ioequ.asm'
        include 'codequ.asm'

pc3ptt          =       1   ;set to 1 if using pc3 as ptt line
pb0ptt          =       1   ;set to 1 if using PB0 as ptt line  (could set both)

ctlwd0          equ     nopreamp+highpass+samprate8+stereo+data16
ctlwd1          equ     immed3state+xtal2select+bits64+codecmaster

outputset       equ     phoneson+lineouton+(leftattn*0)+(rightattn*0)
;increase this value for less transmit output--------^

inputset        equ     mikeselect+(15*monitorattn)+(leftgain*1)+(rightgain*0)

baud    equ     19200      ;SCI baudrate to PC
decsize equ     32         ;size of receive decimation filter
filsize equ     64         ;receive filter 128mS long at 500Hz
hbsize  equ     256        ;serial input buffer size
sample  equ     8000.00    ;system sample rate
sintab  equ     $100       ;address of sine table in ROM

xoncode  equ    $11        ;X-off code to send to PC
xoffcode equ    $13        ;X-on code to send to PC

;data format from PC to evm
; 000000TR       process TR into txbuf for transmission (T=txon, R=reversal)
;                txbuf empties at 31.25Hz
; 0010DDDD       shift DDDD left into lsb-end of 24-bit stack
; 0011XXXX       put 24-bit stack into rxfreq
; 0100XXXX       put 24-bit stack into txfreq

;data format from evm to PC
;PPPPPPP0        P=7-bit receive channel phase (at 500Hz)
;00010011        Xoff code to stop PC sending 000000TRs
;00010001        Xon code to restart PC

;X and Y relocated by request   pm 8/97
        org     X:$18   ;codec receive timeslots
rslot0  dc      0       ;left audio from codec
rslot1  dc      0       ;right audio from codec
rslot2  dc      0       ;output level settings: bit 15 is busy flag
rslot3  dc      0       ;input level settings: bit 21 is overrange flag

ctlset  dc      ctlwd0  ;initialisation values for codec control mode
        dc      ctlwd1
        dc      0
        dc      0

        org     Y:$18     ;codec transmit timeslots
tslot0  dc      0       ;left audio
tslot1  dc      0       ;right audio
tslot2  dc      0       ;output level settings
tslot3  dc      0       ;input level settings: bit 21 is overrange enable

dtaset  dc      0           ;initialisation values for codec data mode
        dc      0
        dc      outputset
        dc      inputset
lastY   =       *

        org     L:lastY  ;oscillators
rxosc   ds      2        ;X:(0)=freq, Y:(0)=phase, X:(1)=cos, Y:(1)=sin
txosc   ds      2        ;X:(0)=freq, Y:(0)=phase, X:(1)=cos, Y:(1)=sin
hposc   ds      2        ;X:(0)=freq, Y:(0)=phase, X:(1)=cos, Y:(1)=sin
rxIQ    ds      1        ;filtered receive I and Q for headphone output
lastL   =       *

        org     X:rxosc     ;initial values for oscillator frequencies
rxfreq  dc      1000.0/sample*2     ;rx freq   (PC can change it)
        org     X:txosc
txfreq  dc      1000.0/sample*2     ;tx freq   (PC can change it)
        org     X:hposc
hpfreq  dc      1000.0/sample*2      ;headphone freq (stays at 1 kHz)

        org     X:lastL
timeslot dc      0                  ;counts 0,1,2,3 at 32kHz
nexttx   dc      0                  ;0, +1, or -1 for next tx bit
lasttx   dc      0                  ;0, +1, or -1 for previous tx bit
txenv    dc      0                  ;transmit envelope value
txdata   dc      0                  ;bit4:toggle, bit5:txon
outhx    dc      xoncode*$10000+1   ;x-code to send to PC (lsb=new code)
outhd    dc      0                  ;phase to send to PC (lsb=new phase)
nstack   dc      0                  ;stack for building Q24s from nybbles

;jump table for bytes from PC (index=bits 6,5,4 of PC byte)
jmptab   dc      txdat              ;put bits 0,1 into txbuf
         dc      hdone
         dc      push4              ;push bits 3,2,1,0 left into stack
         dc      dorxf              ;pop stack into rxfreq
         dc      dotxf              ;pop stack into txfreq
         dc      hdone
         dc      hdone
         dc      hdone 
lastX   =       *

         org    Y:lastL
atncof   dc     -8.69245892963590E-0002   ;power series coeffs for arctan
         dc      3.36924589284536E-0001
pattern  dc     $000000          ;octant 0         bit23: 1=subtract 0=add
         dc     $A00000          ;       1    bits 22,21: quadrant offset
         dc     $800000          ;       7
         dc     $600000          ;       6
         dc     $C00000          ;       3
         dc     $200000          ;       2
         dc     $400000          ;       4
         dc     $E00000          ;       5

;X and Y at $0100..$01FF: Interrupt code loaded here and relocated at
;start-up: ROMs turned-on after startup.

;P:code for bottom $40 loaded in X: (under the ROM)
          org    P:$000C,X:$10C       ;code for P:$0C loaded at X:$10C
          jsr    <ssirx               ;SSI rcv data default handler
          nop
          jsr    <ssirx               ;ssi rcv data error handler
          nop

          org     P:$0020,X:$120      ;code for P:$20 loaded at X:$120
;codec interrupt handler uses no registers!
ssirx     bchg    #0,X:timeslot       ;toggle bit0
          jcs    <oddslot             ;skip if it was 1
evenslot  btst    #1,X:timeslot       ;test bit1
          jcs    <slot2               ;skip if it was 1
slot0     movep   X:M_RX,X:rslot0     ;get left input from codec
          movep   Y:tslot2,X:M_TX     ;put output setting to codec
          rti
oddslot   bchg    #1,X:timeslot       ;toggle bit1
          jcs    <slot3               ;skip if it was 1
slot1     movep   X:M_RX,X:rslot1     ;get right input from codec
          movep   Y:tslot3,X:M_TX     ;put input settings to codec
          rti
slot2     movep   X:M_RX,X:rslot2     ;get output settings from codec
          movep   Y:tslot0,X:M_TX     ;put left audio out to codec
          rti
slot3     movep   X:M_RX,X:rslot3     ;get input settings from codec
          movep   Y:tslot1,X:M_TX     ;put right audio out to codec
          rti

;mustn't load P: below $40 or the bootstrap loader will overwrite itself
        org     P:$40
start   ori     #3,MR           ;disable interrupts
        bclr    #2,OMR          ;disable ROMs
        move    #$100,R1        ;point to X: where P:$0 code is loaded
        move    #$00,R2         ;point to P:destination
        do      #$40,_emov
         move   X:(R1)+,A1
         move   A1,P:(R2)+
_emov   bset    #2,OMR          ;turn ROMs on now
        clr     A
        movep   #$1C0009,X:M_PCTL ;40 Mhz, disable clock output
        movep   A1,X:M_BCR        ;no waits
	movep   #$4303,X:M_CRA    ;40MHz/16 = 2.5MHz SCLK, WL=16 bits, 4W/F
        movep   #$BB30,X:M_CRB    ;rie,re,te, tie not needed
        movep   #$14,X:M_PCDDR    ;setup pc4, pc2 as outputs
       if pc3ptt
	bset   #3,X:M_PCDDR       ;setup pc3 as output
        bclr   #3,X:M_PCD         ;ptt line off
       endif
	movep   #$01E3,X:M_PCC    ;Turn on ssi,sci
       if pb0ptt
        movep   #0,X:M_PBC        ;set portB to general purpose
        movep   #1,X:M_PBDDR      ;set portB bit0 as o/p
        bclr    #0,X:M_PBD        ;ptt line off
       endif
        movep   #$0302,X:M_SCR    ;set SCR async, 8-bit
        movep   #(625000/baud-1),X:M_SCCR     ;set baudrate, internal clocks
	movep   A1,X:M_PCD        ;codec control mode, hit codec reset
	do      #500,_endel       ;50mS delay
	 rep     #2000             ; (100 us delay)
          nop
_endel  bset    #4,X:M_PCD        ;reset off
        movep   #$2000,X:M_IPR    ;IPR=2 for ssi
        move    #ctlset,R1        ;source=codec control-settings
        move    #tslot0,R2        ;destn=transmit slots
        do      #4,_eset
         move   X:(R1)+,X0        ;move them
         move   X0,Y:(R2)+
_eset   andi    #$FC,MR           ;SSI interrupt will now fire
waitfr  wait
        jclr    #2,X:M_SR,waitfr  ;wait for rx frame sync
        move    A1,X:timeslot     ;synchronise the timeslot pointer
wait0   wait
        jset    #18,X:rslot0,wait0   ;wait for CLB=0
        bset    #18,Y:tslot0         ;set CLB=1
wait1   wait
        jclr    #18,X:rslot0,wait1   ;wait for CLB=1
        move   #dtaset,R1            ;source=codec data-settings
        move   #tslot0,R2            ;destn=transmit slots
        do      #4,_eset
         move   Y:(R1)+,A            ;move them
         move   A1,Y:(R2)+
_eset   movep   #$BB00,X:M_CRB       ;set SCLK,FS to input
	bset    #2,X:M_PCD           ;switch to data mode
_cal    wait
        jclr    #15,X:rslot2,_cal    ;wait for calibration to finish
        bset    #0,X:rslot0          ;mark left audio (ssirx clears it)
;done codec setup
;set up data addressing
        move    #$FF,M0              ;size of sine table
                                     ;R0 used on the fly
        move    #filter,R1           ;main receive filter ptr
        move    #filsize-1,M1        ;size of main receive filter
        move    #0,R2                ;just counts 0..255 at 8 kHz
        move    #$FF,M2              ;counter modulo  (32mS cycle)
        move    #decfil,R3           ;decimation filter ptr
        move    #decsize-1,M3        ;decimation filter modulo
                                     ;R4 used on the fly
        move    #$FFFF,M4            ;linear addressing all the time
        move    #monfil,R5           ;headphone interpolation filter
        move    #15,M5               ;headphone interpolation filter modulo
        move    #hinbuf,R6           ;head pointer for SCI input buffer
        move    R6,R7                ;tail pointer for SCI input buffer
        move    #hbsize-1,M6         ;size of SCI input buffer
        move    M6,M7

;this is the main loop
main    wait                         ;cool down until something happens
        jset    #0,X:rslot0,main     ;loop until new left audio input

;get here at 8 kHz
        move    #rxosc,R4                ;point to receive oscillator
        jsr     oscill                   ;do it
        move    X:rslot0,X0   A,Y1       ;get left input and rx osc cosine
        mpyr    X0,Y1,A       B,Y1       ;mix with input, get rx osc sine
        mpyr    X0,Y1,B       (R2)+      ;mix with input: count 31.25Hz
        move    AB,L:(R3)+               ;store I/Q in decimation filter
        bset    #0,X:rslot0              ;mark left audio input as done

        move    R2,B                     ;test for 31.25Hz process
        tst     B
        jne    <txwave

;here at 31.25Hz to fetch next tx bit
        move    X:txdata,X1              ;get last txdata sent
        move    X:nexttx,A
        move    A,X:lasttx               ;move new tx amplitude to old
        move    R6,X0
        move    R7,B                     ;fetch tx buffer pointers
        cmp     X0,B                     ;test if anything to transmit
        jeq    <txbit0                   ;skip to repeat last txdata if empty
        move    X:(R7)+,X1               ;else get new txdata from buffer
        move    X1,X:txdata              ;keep new txdata for next
txbit0  jset    #21,X1,txbit1            ;skip if bit1=1 (carrier on)
        clr     A                        ;amp=0 for carrier off
        jmp    <txbit2
txbit1  tst     A      #$7FFFFF,X0
        teq     X0,A                     ;set amplitude = +1.0 if carrier was off
txbit2  jset    #20,X1,txbit3
        neg     A                        ;toggle amplitude if txdata bit0=0
txbit3  move    A1,X:nexttx              ;put out new amplitude
        jsr     tstemp                   ;send Xon if nearly empty

;now do transmit waveform at 8 kHz
txwave  move    R2,B                     ;get counter
        asr     B           #>$140,X0    ;divide count by 2
        add     X0,B                     ;point into cosine table
        move    B1,R0                    ;move to address register
        move    #$7FFFFF,Y0              ;set Y0=1.0  (pipeline)
        move    Y:(R0),A                 ;get cosine value from ROM
        asr     A           #0.5,X0      ;divide by 2
        add     X0,A                     ;0.5*(1+sin(count/2))=r/cos for last bit
        move    A1,A                     ;normalise A
        neg     A         A,X0           ;0.5*(-1-sin((count/2): save last
        add     Y0,A      X:lasttx,X1    ;0.5*(1-sin(count/2))
        move    A,Y0                     ;Y0=raised-cosine for next bit
        mpy     X0,X1,A   X:nexttx,Y1
        macr    Y0,Y1,A                  ;form composite envelope amplitude
        move    A,X:txenv                ;save result (-1.0 to +1.0)
        jeq    <pttoff                   ;go turn ptt off if zero
ptton
      if pb0ptt
        bset    #0,X:M_PBD
      endif
      if pc3ptt
        bset    #3,X:M_PCD               ;else turn ptt on
      endif
        jmp    <ptt
pttoff
      if pb0ptt
        bclr    #0,X:M_PBD
      endif
      if pc3ptt
        bclr    #3,X:M_PCD
      endif
ptt:
        move    #txfreq,R4               ;point to tx oscillator
        jsr     oscill                   ;do it
        move    B,X0                     ;get tx sine wave
        move    X:txenv,X1
        mpy     X0,X1,A                  ;form tx waveform
        move    A,Y:tslot0               ;tx waveform out

;here do headphone output at 8 kHz
        move    #hpfreq,R4               ;point to headphone oscillator
        jsr     oscill                   ;do it
        move    L:rxIQ,A                 ;get I and Q from rx filter
        move    A10,L:(R5)+              ;put into interpolation filter
        clr     A      L:(R5)+,X         ;clear Isum: get first I/Q
        clr     B      #1.00/16,Y0       ;clear Qsum: set constant coeff
        do      #15,_efil                ;calculate interpolation filter o/p
         mac    X1,Y0,A   X:(R5),X1
         mac    X0,Y0,B   Y:(R5)+,X0
_efil   macr    X1,Y0,A
        macr    X0,Y0,B   A,X1      ;interpolated I and Q now in A and B
        move    L:(R4),Y            ;get cos(hpfreq) and sin(hpfreq)
        mpy     X1,Y1,A   B,X0      ;multiply rxI, get rxQ
        macr    X0,Y0,A             ;mpy rxQ and add
        move    A1,Y:tslot1         ;output rx audio to right headphone

;process data from SCI input into host input buffer
        jclr    #2,X:M_SSR,hdone         ;skip if no byte waiting
        movep   X:M_SRXH,A0              ;get byte from SCI
        move     #>$000007,X0
        rep     #4
         asl    A                        ;move commandbits into A1
        and      X0,A    #jmptab,N4      ;mask command bits, setup jumptable
        move     A1,R4
        nop
        move    X:(R4+N4),R4             ;get address from jump table
        nop
        jmp     (R4)                     ;do the command, data in 4msb of A0

;command=0, put data into tx buffer
txdat   move    R7,B                     ;get tail ptr
        lua     (R6)+,R4                 ;form bumped head ptr to test for full
        move    R4,X0
        cmp     X0,B                     ;test head=tail
        jeq    <hdone                    ;abort if absolutely full
        move    A0,X:(R6)+               ;put data into buffer
        jsr     tstfull                  ;send Xoff to PC if nearly full
        jmp    <hdone

;command=2, shift data into 24-bit stack
push4   move    X:nstack,A1              ;get nybble stack
        rep     #4
         asl    A                        ;shift new nybble into it
        move    A1,X:nstack              ;put new nybble stack away
        jmp    <hdone

;command=3, copy stack to rx frequency
dorxf   move    X:nstack,A
        move    A,X:rxfreq
        jmp    <hdone

;command=4, copy stack to tx frequency
dotxf   move     X:nstack,A
        move     A,X:txfreq
hdone                                    ;command=else

;process received phase data and xonoff codes to SCI output
        jclr   #1,X:M_SSR,hout2         ;skip if SCI tx busy
        jclr   #0,X:outhx,hout1         ;skip if no new X-code to send
        bclr   #0,X:outhx               ;mark it as sent
        movep  X:outhx,X:M_STXH         ;send it
        jmp   <hout2
hout1   jclr   #0,X:outhd,hout2         ;skip if no new phase to send
        bclr   #0,X:outhd               ;mark it as sent
        movep  X:outhd,X:M_STXH         ;send it
hout2

        move    R2,B                ;test for 500Hz processes
        move    #>15,X0
        and     X0,B      #>8,X0       ;mask to 0..15
        cmp     X0,B                   ;test for count=8
        jne     main                   ;skip if not((count mod 16)=8)

;here at 500Hz interleaved between 31.25Hz processes
;receive decimation filter calculation
        clr     A        #deccofs,R4
        clr     B
        move    X:(R4)+,X0              ;get 1st coeff
        move    L:(R3)+,Y               ;get I/Q
        do      #decsize-1,rxf0
         mac    X0,Y1,A  X:(R3),Y1
         mac    X0,Y0,B  Y:(R3)+,Y0  X:(R4)+,X0
rxf0    macr    X0,Y1,A
        macr    X0,Y0,B     
        move    AB,L:(R1)+         ;decimation filter output into main filter

        clr     A        #coeffs,R4
        clr     B
        move    X:(R4)+,X0                       ;get 1st coeff
        move    L:(R1)+,Y                        ;get I/Q
        do      #filsize-1,rxf1                  ;do main filter
         mac    X0,Y1,A  X:(R1),Y1               ;do Istep
         mac    X0,Y0,B  Y:(R1)+,Y0 X:(R4)+,X0   ;do Qstep
rxf1    macr   X0,Y1,A                           ;do last macs
        macr   X0,Y0,B                           ;and round off
        move   AB,L:rxIQ                         ;save for headphone output

;now calculate the phase angle from the I and Q values
arctan  move    #pattern,R4                 ;R4 will point to octant
        tst     A           #4,N4
        jpl    <atan1
        abs     A           (R4)+N4         ;if I<0  then add 4 to R4
atan1   tst     B           #2,N4
        jpl    <atan2
        abs     B           (R4)+N4         ;if Q<0 then add 2 to R4
atan2   cmp     A,B         A,X0
        jmi    <atan3
        tfr     X0,B        B,X0            ;if Q>I then swap..
        move    (R4)+                       ;and add 1 to R4
atan3   move    R4,N4                       ;save octant pointer in N4 temp
        move    #atncof,R4                  ;point to coefficients
        andi    #$FE,ccr                    ;clear carry bit
        rep     #24
         div    X0,B                        ;divide to get tangent
        move    B0,X1                       ;quotient to X1 =tan
        move    Y:(R4)+,X0                  ;get 2nd-order coefficient
        mpyr    X0,X1,A     Y:(R4),X0       ;k2*tan, fetch k1
        add     X0,A                        ;k2*tan+k1
        move    A,X0
        mpyr    X0,X1,A    N4,R4            ;(k2*tan+k1)*tan: get octant
        move    A1,X1
        move    Y:(R4),A                    ;get octant pattern/offset
        asl     A                           ;shift msb to carry
        jcc    <atan4
        sub     X1,A                        ;if C set then subtract from
        jmp    <atan5
atan4   add     X1,A                        ;if C clr then add to
atan5                                       ;4-quad phase value now in A1

;feed phase value to output at 500Hz
        bclr    #16,A1                      ;mask to 7msb
        bset    #0,A1                       ;mark it as new
        move    A1,X:outhd                  ;put out for sending to PC
        jmp     main

;test input buffer for full/empty, update outhx for sending to host
tstfull move    #xoffcode,X1
        move    R6,B               ;get head pointer
        move    R7,A               ;get tail pointer
        jmp    <tstemp1

tstemp  move    #xoncode,X1
        move    R6,A                    ;get head pointer
        move    R7,B                    ;get tail pointer
tstemp1 sub     B,A        #>hbsize,B   ;subtract to get difference
        jcc    <tstemp2
        add     B,A                     ;unwrap if carry set
tstemp2 asr     B                       ;halve buffer size
        sub     B,A                     ;see if more than half full/empty
        jcc    <tstemp3                 ;skip if not
        move    X:outhx,A               ;get last x-code sent to PC
        bclr    #0,A                    ;mask off "sent" bit
        cmp     X1,A                    ;see if last sent was same
        jeq    <tstemp3                 ;if so then don't send another
        bset    #0,X1                   ;else mark it to send
        move    X1,X:outhx              ;put X-code to send to PC
tstemp3 rts                             

;this subroutine, called at 8 kHz, runs the oscillator that R4 is pointing
;at and returns it's cos and sin values in A and B and L:(R4)  (tnx SP9VRC)
oscill  move	X:(R4),A                  ;get frequency
        move    Y:(R4),X0                 ;get current phase
	add	X0,A	    #>$80,X1      ;add frequency to phase
	move	A1,Y:(R4)+                ;save new phase
	mpy     X0,X1,A     #>$FF,X0      ;shift right 16, remainder to A0
        and     X0,A        #$100,X0      ;mask A1 to 8 lsb
	or      X0,A        #$40,N0       ;form sine ROM table address
	move    A1,R0                     ;move ROM address to R0
	move    A0,Y0                     ;move remainder to Y0
	jclr    #23,Y0,round
	move    (R0)+                     ;round up if Y0>$7FFFFF
round	move    Y:(R0+N0),X0              ;X0=coarse cosine
	move    Y:(R0),X1                 ;X1=coarse sine
	mpyr    X1,Y0,A    #PI/256.0,Y1   ;A=sin*rem
       	tfr     X0,A       A,X1           ;fetch cos, move sin*rem
	macr   -X1,Y1,A                   ;A=cos-sin*rem*pi/256 (=fine cos)
	mpyr    X0,Y0,B    Y:(R0),X1      ;B=cos*rem, read sin again
	tfr     X1,B       B,X1           ;fetch sin, move cos*rem
	macr    X1,Y1,B    A,X:(R4)       ;B=sin+cos*rem*pi/256 (=fine sine)
        move    B,Y:(R4)+                 ;save sine
        rts
lastP   =       *

      if @cvi(lastP)>$200
        org    L:lastP           ;make sure we are above the program
      else
        org    L:$200            ;..and above the ROM
      endif

monfil   dsm    16               ;interpolation filter for headphone output

decfil   dsm    decsize          ;decimation I/Q filters
lastL    =      *

         org    X:lastL
deccofs  equ *          ;triangular decimation filter (96db down at +/-500Hz)
count    set     0
total    =       @cvf(decsize)*@cvf(decsize)/2
         dup     decsize
       if count<16
         dc      @cvf(2*count+1)/total
       else
         dc      @cvf(2*(decsize-count)-1)/total
       endif
count    set     count+1
       endm
lastX    =      *

         org    L:lastX
filter   dsm    filsize        ;main receive I/Q filters
lastL    =      *
         org    X:lastL
coeffs   equ    *
PI       equ    3.14159265358979323846

s0       equ    0.5            ;DFT factors for main filter
s1       equ    1.15           ;>=64dB at >=31.25 Hz
s2       equ    0.7931
s3       equ    0.1567
s4       equ    0.00049
s5       equ    0.0005

time     =     -0.5*@cvf(filsize)+0.5
count    set    0
	 dup    filsize
angle    =      2*PI*time/@cvf(filsize)
coeff    =      s0+s1*@cos(angle)+s2*@cos(2.0*angle)+s3*@cos(3.0*angle)+s4*@cos(4.0*angle)+s5*@cos(5.0*angle)
time     =      time+1.0
	 dc     2*coeff/filsize
count    set    count+1
	 endm
lastL    =      *

         org    X:lastL
hinbuf   dsm    hbsize       ;tx data in from PC

        end     start